/* ~[ebNX̃Tv */
/* cc -lpthread -o mutex mutex.c (Linux) */
#include<stdio.h>
#include<pthread.h>

pthread_mutex_t	mutex;						/*	~[ebNX				*/

int
main(void);
void*
func1(void*	pParam);
void*
func2(void*	pParam);

void*
func1(void*	pParam)
{
	int	i;

	for(i = 0;i < 10;i++)
	{
		pthread_mutex_lock(&mutex);			/*	~[ebNX擾			*/
		printf("output");
		usleep(0);
		printf(" by");
		usleep(0);
		printf(" func1 i = %d\n",i);
		pthread_mutex_unlock(&mutex);		/*	~[ebNX			*/
	}

	return NULL;
}

void*
func2(void*	pParam)
{
	int	i;

	for(i = 0;i < 10;i++)
	{
		pthread_mutex_lock(&mutex);			/*	~[ebNX擾			*/
		printf("OUTPUT");
		usleep(0);
		printf(" BY");
		usleep(0);
		printf(" FUNC2 I = %d\n",i);
		pthread_mutex_unlock(&mutex);		/*	~[ebNX			*/
	}

	return NULL;
}

int
main(void)
{
	pthread_t	tid1;
	pthread_t	tid2;

	pthread_mutex_init(&mutex,NULL);		/*	~[ebNX		*/
											/*	XbhP				*/
	if(pthread_create(&tid1,NULL,func1,NULL) != 0)
	{
		perror("pthread_create");
	}
											/*	XbhQ				*/
	if(pthread_create(&tid2,NULL,func2,NULL) != 0)
	{
		perror("pthread_create");
	}

											/*	XbhPI҂			*/
	if(pthread_join(tid1,NULL) != 0)
	{
		perror("pthred_join");
	}
											/*	XbhQI҂			*/
	if(pthread_join(tid2,NULL) != 0)
	{
		perror("pthred_join");
	}

	pthread_mutex_destroy(&mutex);			/*	~[ebNXj			*/
											/*	ALinux̎ł͈Ӗ	*/
											/*	Ȃ悤ł			*/
	
	return 0;
}
